## sptag 0.0~git20211209.a84a9e4%2Bds

=== CMakeLists.txt ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.

cmake_minimum_required (VERSION 3.12)

project (SPTAGLib)

function(CXX_COMPILER_DUMPVERSION _OUTPUT_VERSION)
  exec_program(${CMAKE_CXX_COMPILER}
    ARGS ${CMAKE_CXX_COMPILER_ARG1} -dumpversion
    OUTPUT_VARIABLE COMPILER_VERSION
  )

  set(${_OUTPUT_VERSION} ${COMPILER_VERSION} PARENT_SCOPE)
endfunction()

if(NOT WIN32)
    CXX_COMPILER_DUMPVERSION(CXX_COMPILER_VERSION)
endif()

if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    # require at least gcc 5.0
    if (CXX_COMPILER_VERSION VERSION_LESS 5.0)
        message(FATAL_ERROR "GCC version must be at least 5.0!")
    endif()
    set (CMAKE_CXX_FLAGS "-Wall -Wunreachable-code -Wno-reorder -Wno-sign-compare -Wno-unknown-pragmas -Wcast-align -lm -lrt -std=c++14 -fopenmp")
    set (CMAKE_CXX_FLAGS_RELEASE "-DNDEBUG -O3 -march=native")
    set (CMAKE_CXX_FLAGS_DEBUG   "-g -DDEBUG")
elseif(WIN32)
    if(NOT MSVC14)
         message(FATAL_ERROR "On Windows, only MSVC version 14 are supported!") 
    endif()
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /std:c++14")

    message(STATUS "CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
else ()
    message(FATAL_ERROR "Unrecognized compiler (use GCC or MSVC)!")
endif()

if (NOT CMAKE_BUILD_TYPE)
    set (CMAKE_BUILD_TYPE Release CACHE STRING "Build types: Release Debug" FORCE)
endif()
message (STATUS "Build type: ${CMAKE_BUILD_TYPE}")

if (${CMAKE_SIZEOF_VOID_P} EQUAL "8")
    set (PROJECTNAME_ARCHITECTURE "x64")
else ()
    set (PROJECTNAME_ARCHITECTURE "x86")
endif ()
message (STATUS "Platform type: ${PROJECTNAME_ARCHITECTURE}")

set(Boost_USE_MULTITHREADED ON)

if (WIN32)
    set(Boost_USE_STATIC_LIBS ON)

    set(CMAKE_CONFIGURATION_TYPES ${CMAKE_BUILD_TYPE})
    set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
    set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
    set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

    set (LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/${CMAKE_CFG_INTDIR})
    set (EXECUTABLE_OUTPUT_PATH ${CMAKE_BINARY_DIR}/${CMAKE_CFG_INTDIR})
else()
    set (LIBRARY_OUTPUT_PATH "${PROJECT_SOURCE_DIR}/${CMAKE_BUILD_TYPE}/")
    set (EXECUTABLE_OUTPUT_PATH "${PROJECT_SOURCE_DIR}/${CMAKE_BUILD_TYPE}/")
endif()

set (CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR})

find_package(OpenMP)
if (OpenMP_FOUND)
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS}")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS}")
    set (CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${OpenMP_EXE_LINKER_FLAGS}")
    message (STATUS "Found openmp.")
else()
    message (FATAL_ERROR "Could no find openmp!")
endif()

find_package(Boost 1.67 COMPONENTS system thread serialization wserialization regex filesystem)
if (Boost_FOUND)
    include_directories (${Boost_INCLUDE_DIR})
    link_directories (${Boost_LIBRARY_DIR})
    message (STATUS "Found Boost.")
    message (STATUS "Include Path: ${Boost_INCLUDE_DIRS}")
    message (STATUS "Library Path: ${Boost_LIBRARY_DIRS}")
    message (STATUS "Library: ${Boost_LIBRARIES}")
else()
    message (FATAL_ERROR "Could not find Boost >= 1.67!")
endif()

option(GPU "GPU" ON)
option(LIBRARYONLY "LIBRARYONLY" OFF)
add_subdirectory (AnnService)
add_subdirectory (Test)
add_subdirectory (GPUSupport)
add_subdirectory (Wrappers)

=== AnnService/CMakeLists.txt ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.

set(AnnService ${PROJECT_SOURCE_DIR}/AnnService)

include_directories(${AnnService})

file(GLOB_RECURSE HDR_FILES ${AnnService}/inc/Core/*.h  ${AnnService}/inc/Helper/*.h)
file(GLOB_RECURSE SRC_FILES ${AnnService}/src/Core/*.cpp ${AnnService}/src/Helper/*.cpp)

list(REMOVE_ITEM HDR_FILES
    ${AnnService}/inc/Core/Common/DistanceUtils.h 
    ${AnnService}/inc/Core/Common/InstructionUtils.h
    ${AnnService}/inc/Core/Common/CommonUtils.h
    )

list(REMOVE_ITEM SRC_FILES
    ${AnnService}/src/Core/Common/DistanceUtils.cpp
    ${AnnService}/src/Core/Common/InstructionUtils.cpp
    )

add_library (DistanceUtils STATIC 
    inc/Core/Common/DistanceUtils.h 
    inc/Core/Common/InstructionUtils.h
    inc/Core/Common/CommonUtils.h
    inc/Core/Common/IQuantizer.h
    src/Core/Common/DistanceUtils.cpp
    src/Core/Common/InstructionUtils.cpp
    )

if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    target_compile_options(DistanceUtils PRIVATE -mavx2 -mavx -msse -msse2 -fPIC)
endif()

add_library (SPTAGLib SHARED ${SRC_FILES} ${HDR_FILES})
target_link_libraries (SPTAGLib DistanceUtils)
add_library (SPTAGLibStatic STATIC ${SRC_FILES} ${HDR_FILES})
target_link_libraries (SPTAGLibStatic DistanceUtils)
if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
    target_compile_options(SPTAGLibStatic PRIVATE -fPIC)
endif()

install(TARGETS SPTAGLib SPTAGLibStatic
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib)

if (NOT LIBRARYONLY)
    file(GLOB SERVER_HDR_FILES ${AnnService}/inc/Server/*.h ${AnnService}/inc/Socket/*.h)
    file(GLOB SERVER_FILES ${AnnService}/src/Server/*.cpp ${AnnService}/src/Socket/*.cpp)
    add_executable (server ${SERVER_FILES} ${SERVER_HDR_FILES})
    target_link_libraries(server ${Boost_LIBRARIES} SPTAGLibStatic)

    file(GLOB CLIENT_HDR_FILES ${AnnService}/inc/Client/*.h ${AnnService}/inc/Socket/*.h)
    file(GLOB CLIENT_FILES ${AnnService}/src/Client/*.cpp ${AnnService}/src/Socket/*.cpp)
    add_executable (client ${CLIENT_FILES} ${CLIENT_HDR_FILES})
    target_link_libraries(client ${Boost_LIBRARIES} SPTAGLibStatic)

    file(GLOB AGG_HDR_FILES ${AnnService}/inc/Aggregator/*.h ${AnnService}/inc/Socket/*.h ${AnnService}/inc/Server/QueryParser.h)
    file(GLOB AGG_FILES ${AnnService}/src/Aggregator/*.cpp ${AnnService}/src/Socket/*.cpp ${AnnService}/src/Server/QueryParser.cpp)
    add_executable (aggregator ${AGG_FILES} ${AGG_HDR_FILES})
    target_link_libraries(aggregator ${Boost_LIBRARIES} SPTAGLibStatic)

    file(GLOB BUILDER_FILES ${AnnService}/src/IndexBuilder/*.cpp)
    add_executable (indexbuilder ${BUILDER_FILES})
    target_link_libraries(indexbuilder ${Boost_LIBRARIES} SPTAGLibStatic)

    file(GLOB SEARCHER_FILES ${AnnService}/src/IndexSearcher/*.cpp)
    add_executable (indexsearcher ${SEARCHER_FILES})
    target_link_libraries(indexsearcher ${Boost_LIBRARIES} SPTAGLibStatic)
    
    install(TARGETS server client aggregator indexbuilder indexsearcher
      RUNTIME DESTINATION bin
      ARCHIVE DESTINATION lib
      LIBRARY DESTINATION lib)
endif()

set(VECTORSEARCH_INC_DIR ${AnnService}/inc/SSDServing/VectorSearch)
set(VECTORSEARCH_IMP_DIR ${AnnService}/src/SSDServing/VectorSearch)
file(GLOB_RECURSE SSD_SERVING_HDR_FILES ${AnnService}/inc/SSDServing/*.h)
file(GLOB_RECURSE SSD_SERVING_FILES ${AnnService}/src/SSDServing/*.cpp)
if(NOT WIN32)
    list(REMOVE_ITEM SSD_SERVING_HDR_FILES 
            ${VECTORSEARCH_INC_DIR}/AsyncFileReader.h
            )
elseif(WIN32)
    list(REMOVE_ITEM SSD_SERVING_HDR_FILES 
            ${VECTORSEARCH_INC_DIR}/AsyncFileReaderLinux.h
            )
endif()

add_executable(ssdserving ${SSD_SERVING_HDR_FILES} ${SSD_SERVING_FILES})
target_link_libraries(ssdserving SPTAGLibStatic ${Boost_LIBRARIES})
target_compile_definitions(ssdserving PRIVATE _exe)

# for Test
add_library(ssdservingLib ${SSD_SERVING_HDR_FILES} ${SSD_SERVING_FILES})
target_link_libraries(ssdservingLib SPTAGLibStatic ${Boost_LIBRARIES})

find_package(MPI)
if (MPI_FOUND)
    message (STATUS "Found MPI.")
    message (STATUS "MPI Include Path: ${MPI_CXX_INCLUDE_PATH}")
    message (STATUS "MPI Libraries: ${MPI_CXX_LIBRARIES}")
    include_directories (${MPI_CXX_INCLUDE_PATH})
    file(GLOB PARTITION_FILES ${AnnService}/src/BalancedDataPartition/*.cpp)
    add_executable(balanceddatapartition ${PARTITION_FILES})
    target_link_libraries(balanceddatapartition SPTAGLibStatic ${Boost_LIBRARIES} ${MPI_CXX_LIBRARIES})
endif()

install(TARGETS ssdservingLib ssdserving
  RUNTIME DESTINATION bin
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib)

=== GPUSupport/CMakeLists.txt ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.

find_package(CUDA)

if (NOT GPU)
    set (CUDA_FOUND false)
endif()

if (CUDA_FOUND)
    message (STATUS "Found cuda.")
    message (STATUS "Include Path:" ${CUDA_INCLUDE_DIRS})
    message (STATUS "Library Path:" ${CUDA_LIBRARIES})
    if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
        set (CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -Xcompiler -fPIC -Xcompiler -fopenmp -std=c++14 -Xptxas -O3 --use_fast_math --disable-warnings
        -gencode arch=compute_70,code=sm_70
        -gencode arch=compute_61,code=sm_61
        -gencode arch=compute_60,code=sm_60" )
    elseif(WIN32)
        set (CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -Xcompiler /openmp -Xcompiler /std:c++14 -Xcompiler /Zc:__cplusplus -Xcompiler /FS --use_fast_math
        -gencode arch=compute_70,code=sm_70
        -gencode arch=compute_61,code=sm_61
        -gencode arch=compute_60,code=sm_60" )
    endif()

    message (STATUS "CUDA_NVCC_FLAGS:" ${CUDA_NVCC_FLAGS})

    set(AnnService ${PROJECT_SOURCE_DIR}/AnnService)

    include_directories(${AnnService})

    file(GLOB_RECURSE GPU_HDR_FILES ${AnnService}/inc/Core/*.h  ${AnnService}/inc/Helper/*.h ${AnnService}/inc/Core/Common/cuda/*)
    file(GLOB_RECURSE GPU_SRC_FILES ${AnnService}/src/Core/*.cpp ${AnnService}/src/Helper/*.cpp ${AnnService}/src/Core/Common/Kernel.cu)

    list(REMOVE_ITEM GPU_HDR_FILES
        ${AnnService}/inc/Core/Common/DistanceUtils.h
        ${AnnService}/inc/Core/Common/InstructionUtils.h
        ${AnnService}/inc/Core/Common/CommonUtils.h
    )
    list(REMOVE_ITEM GPU_SRC_FILES
        ${AnnService}/src/Core/Common/DistanceUtils.cpp
        ${AnnService}/src/Core/Common/InstructionUtils.cpp
    )

    set_source_files_properties(${GPU_SRC_FILES} PROPERTIES CUDA_SOURCE_PROPERTY_FORMAT OBJ)
    if (${CMAKE_BUILD_TYPE} STREQUAL "Debug")
        set(Definition -DGPU -DDEBUG)
    else()
        set(Definition -DGPU)
    endif()

    CUDA_ADD_LIBRARY(GPUSPTAGLib SHARED ${GPU_SRC_FILES} ${GPU_HDR_FILES})
    target_link_libraries(GPUSPTAGLib DistanceUtils ${Boost_LIBRARIES} ${CUDA_LIBRARIES})
    target_compile_definitions(GPUSPTAGLib PRIVATE ${Definition})

    CUDA_ADD_LIBRARY(GPUSPTAGLibStatic STATIC ${GPU_SRC_FILES} ${GPU_HDR_FILES})
    target_link_libraries(GPUSPTAGLibStatic DistanceUtils ${Boost_LIBRARIES} ${CUDA_LIBRARIES})
    target_compile_definitions(GPUSPTAGLibStatic PRIVATE ${Definition})
    add_dependencies(GPUSPTAGLibStatic GPUSPTAGLib)

    CUDA_ADD_EXECUTABLE(gpuindexbuilder ${AnnService}/src/IndexBuilder/main.cpp)
    target_link_libraries(gpuindexbuilder GPUSPTAGLibStatic ${Boost_LIBRARIES} ${CUDA_LIBRARIES})
    target_compile_definitions(gpuindexbuilder PRIVATE ${Definition})

    set(VECTORSEARCH_INC_DIR ${AnnService}/inc/SSDServing/VectorSearch)
    set(VECTORSEARCH_IMP_DIR ${AnnService}/src/SSDServing/VectorSearch)
    file(GLOB_RECURSE SSD_SERVING_HDR_FILES ${AnnService}/inc/SSDServing/*.h)
    file(GLOB_RECURSE SSD_SERVING_FILES ${AnnService}/src/SSDServing/*.cpp)
    if(NOT WIN32)
        list(REMOVE_ITEM SSD_SERVING_HDR_FILES 
            ${VECTORSEARCH_INC_DIR}/AsyncFileReader.h
            )
    elseif(WIN32)
        list(REMOVE_ITEM SSD_SERVING_HDR_FILES
            ${VECTORSEARCH_INC_DIR}/AsyncFileReaderLinux.h
            )
    endif()

    CUDA_ADD_EXECUTABLE(gpussdserving ${SSD_SERVING_HDR_FILES} ${SSD_SERVING_FILES})
    target_link_libraries(gpussdserving GPUSPTAGLibStatic ${Boost_LIBRARIES} ${CUDA_LIBRARIES})
    target_compile_definitions(gpussdserving PRIVATE ${Definition} _exe)
else()
    message (STATUS "Could not find cuda.")
endif()

=== Test/CMakeLists.txt ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.

if (NOT LIBRARYONLY)
    if(NOT WIN32)
      ADD_DEFINITIONS(-DBOOST_TEST_DYN_LINK)
      message (STATUS "BOOST_TEST_DYN_LINK")
    endif()

    find_package(Boost 1.67 COMPONENTS system thread serialization wserialization regex filesystem unit_test_framework)
    if (Boost_FOUND)
        include_directories (${Boost_INCLUDE_DIR})
        link_directories (${Boost_LIBRARY_DIR})
        message (STATUS "Found Boost.")
        message (STATUS "Include Path: ${Boost_INCLUDE_DIRS}")
        message (STATUS "Library Path: ${Boost_LIBRARY_DIRS}")
        message (STATUS "Library: ${Boost_LIBRARIES}")
    else()
        message (FATAL_ERROR "Could not find Boost 1.67!")
    endif()

    include_directories(${PROJECT_SOURCE_DIR}/AnnService ${PROJECT_SOURCE_DIR}/Test)

    file(GLOB TEST_HDR_FILES ${PROJECT_SOURCE_DIR}/Test/inc/Test.h)
    file(GLOB TEST_SRC_FILES ${PROJECT_SOURCE_DIR}/Test/src/*.cpp)
    add_executable(SPTAGTest ${TEST_SRC_FILES} ${TEST_HDR_FILES})
    target_link_libraries(SPTAGTest SPTAGLibStatic ssdservingLib ${Boost_LIBRARIES})

    install(TARGETS SPTAGTest
      RUNTIME DESTINATION bin  
      ARCHIVE DESTINATION lib
      LIBRARY DESTINATION lib)
endif()

=== Wrappers/CMakeLists.txt ===
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License.

find_package(Python2 COMPONENTS Development)

find_package(CUDA)

if (NOT GPU)
    set (CUDA_FOUND false)
endif()

if (CUDA_FOUND)
    message (STATUS "Found cuda.")
    set (Python2_FOUND false)
else()
    message (STATUS "Could not find cuda.")
endif()

if (Python2_FOUND)
    include_directories (${Python2_INCLUDE_DIRS})
    link_directories (${Python2_LIBRARY_DIRS})
    set (Python_INCLUDE_DIRS ${Python2_INCLUDE_DIRS})
    set (Python_LIBRARIES ${Python2_LIBRARIES})
    set (Python_FOUND true)
else()
    find_package(Python3 COMPONENTS Development)
    if (Python3_FOUND)
        include_directories (${Python3_INCLUDE_DIRS})
        link_directories (${Python3_LIBRARY_DIRS})
        set (Python_INCLUDE_DIRS ${Python3_INCLUDE_DIRS})
        set (Python_LIBRARIES ${Python3_LIBRARIES})
        set (Python_FOUND true)
    endif()
endif()

if (Python_FOUND)
    message (STATUS "Found Python.")
    message (STATUS "Include Path: ${Python_INCLUDE_DIRS}")
    message (STATUS "Library Path: ${Python_LIBRARIES}")

    if (WIN32)
        set(PY_SUFFIX .pyd)
    else()
        set(PY_SUFFIX .so)
    endif()

    execute_process(COMMAND swig -python -c++ -I${PROJECT_SOURCE_DIR}/Wrappers/inc -o ${PROJECT_SOURCE_DIR}/Wrappers/inc/CoreInterface_pwrap.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/PythonCore.i)
    execute_process(COMMAND swig -python -c++ -I${PROJECT_SOURCE_DIR}/Wrappers/inc -o ${PROJECT_SOURCE_DIR}/Wrappers/inc/ClientInterface_pwrap.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/PythonClient.i)

    include_directories(${PYTHON_INCLUDE_PATH} ${PROJECT_SOURCE_DIR}/AnnService ${PROJECT_SOURCE_DIR}/Wrappers)

    file(GLOB CORE_HDR_FILES ${PROJECT_SOURCE_DIR}/Wrappers/inc/CoreInterface.h)
    file(GLOB CORE_SRC_FILES ${PROJECT_SOURCE_DIR}/Wrappers/src/CoreInterface.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/CoreInterface_pwrap.cpp)
    add_library (_SPTAG SHARED ${CORE_SRC_FILES} ${CORE_HDR_FILES})
    set_target_properties(_SPTAG PROPERTIES PREFIX "" SUFFIX ${PY_SUFFIX})
    if (CUDA_FOUND)
        target_link_libraries(_SPTAG GPUSPTAGLibStatic ${Python_LIBRARIES})
    else()
        target_link_libraries(_SPTAG SPTAGLibStatic ${Python_LIBRARIES})
    endif()
    add_custom_command(TARGET _SPTAG POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/Wrappers/inc/SPTAG.py ${EXECUTABLE_OUTPUT_PATH})

    file(GLOB CLIENT_HDR_FILES ${PROJECT_SOURCE_DIR}/Wrappers/inc/ClientInterface.h ${PROJECT_SOURCE_DIR}/AnnService/inc/Socket/*.h ${PROJECT_SOURCE_DIR}/AnnService/inc/Client/*.h)
    file(GLOB CLIENT_SRC_FILES ${PROJECT_SOURCE_DIR}/Wrappers/src/ClientInterface.cpp ${PROJECT_SOURCE_DIR}/AnnService/src/Socket/*.cpp ${PROJECT_SOURCE_DIR}/AnnService/src/Client/*.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/ClientInterface_pwrap.cpp)
    add_library (_SPTAGClient SHARED ${CLIENT_SRC_FILES} ${CLIENT_HDR_FILES})
    set_target_properties(_SPTAGClient PROPERTIES PREFIX "" SUFFIX ${PY_SUFFIX})
    target_link_libraries(_SPTAGClient SPTAGLibStatic ${Python_LIBRARIES} ${Boost_LIBRARIES})
    add_custom_command(TARGET _SPTAGClient POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy ${PROJECT_SOURCE_DIR}/Wrappers/inc/SPTAGClient.py ${EXECUTABLE_OUTPUT_PATH})

    install(TARGETS _SPTAG _SPTAGClient
    RUNTIME DESTINATION bin
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib)
    install(FILES ${PROJECT_SOURCE_DIR}/Wrappers/inc/SPTAG.py ${PROJECT_SOURCE_DIR}/Wrappers/inc/SPTAGClient.py DESTINATION bin)
else()
    message (STATUS "Could not find Python.")
endif()

find_package(JNI)
if (JNI_FOUND)
    include_directories (${JNI_INCLUDE_DIRS})
    link_directories (${JNI_LIBRARY_DIRS})
    message (STATUS "Found JNI.")
    message (STATUS "Include Path: ${JNI_INCLUDE_DIRS}")
    message (STATUS "Library Path: ${JNI_LIBRARIES}")

    if (WIN32)
        set (JAVA_SUFFIX .dll)
    else()
        set (JAVA_SUFFIX .so)
    endif()

    execute_process(COMMAND swig -java -c++ -I${PROJECT_SOURCE_DIR}/Wrappers/inc -o ${PROJECT_SOURCE_DIR}/Wrappers/inc/CoreInterface_jwrap.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/JavaCore.i)
    execute_process(COMMAND swig -java -c++ -I${PROJECT_SOURCE_DIR}/Wrappers/inc -o ${PROJECT_SOURCE_DIR}/Wrappers/inc/ClientInterface_jwrap.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/JavaClient.i)

    include_directories(${JNI_INCLUDE_DIRS} ${PROJECT_SOURCE_DIR}/AnnService ${PROJECT_SOURCE_DIR}/Wrappers)

    file(GLOB CORE_HDR_FILES ${PROJECT_SOURCE_DIR}/Wrappers/inc/CoreInterface.h)
    file(GLOB CORE_SRC_FILES ${PROJECT_SOURCE_DIR}/Wrappers/src/CoreInterface.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/CoreInterface_jwrap.cpp)
    add_library (JAVASPTAG SHARED ${CORE_SRC_FILES} ${CORE_HDR_FILES})
    set_target_properties(JAVASPTAG PROPERTIES SUFFIX ${JAVA_SUFFIX})
    target_link_libraries(JAVASPTAG SPTAGLibStatic ${JNI_LIBRARIES})

    file(GLOB CLIENT_HDR_FILES ${PROJECT_SOURCE_DIR}/Wrappers/inc/ClientInterface.h ${PROJECT_SOURCE_DIR}/AnnService/inc/Socket/*.h ${PROJECT_SOURCE_DIR}/AnnService/inc/Client/*.h)
    file(GLOB CLIENT_SRC_FILES ${PROJECT_SOURCE_DIR}/Wrappers/src/ClientInterface.cpp ${PROJECT_SOURCE_DIR}/AnnService/src/Socket/*.cpp ${PROJECT_SOURCE_DIR}/AnnService/src/Client/*.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/ClientInterface_jwrap.cpp)
    add_library (JAVASPTAGClient SHARED ${CLIENT_SRC_FILES} ${CLIENT_HDR_FILES})
    set_target_properties(JAVASPTAGClient PROPERTIES SUFFIX ${JAVA_SUFFIX})
    target_link_libraries(JAVASPTAGClient SPTAGLibStatic ${JNI_LIBRARIES} ${Boost_LIBRARIES})

    file(GLOB JAVA_FILES ${PROJECT_SOURCE_DIR}/Wrappers/inc/*.java)
    foreach(JAVA_FILE ${JAVA_FILES})
        message (STATUS "Add copy post-command for file " ${JAVA_FILE})
        add_custom_command(TARGET JAVASPTAGClient POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy ${JAVA_FILE} ${EXECUTABLE_OUTPUT_PATH})
    endforeach(JAVA_FILE)

    install(TARGETS JAVASPTAG JAVASPTAGClient
    RUNTIME DESTINATION bin
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib)
    install(FILES ${JAVA_FILES} DESTINATION bin)
else()
    message (STATUS "Could not find JNI.")
endif()

if (WIN32)
    if (${PROJECTNAME_ARCHITECTURE} MATCHES "x64")
        set (csharp_dotnet_framework_hints "$ENV{windir}\\Microsoft.NET\\Framework64")
    else()
        set (csharp_dotnet_framework_hints "$ENV{windir}\\Microsoft.NET\\Framework")
    endif()

    file(GLOB_RECURSE csharp_dotnet_executables ${csharp_dotnet_framework_hints}/csc.exe)
    list(SORT csharp_dotnet_executables)
    list(REVERSE csharp_dotnet_executables)
    foreach (csharp_dotnet_executable ${csharp_dotnet_executables})
        if (NOT DEFINED DOTNET_FOUND)
            string(REPLACE "${csharp_dotnet_framework_hints}/" "" csharp_dotnet_version_temp ${csharp_dotnet_executable})
            string(REPLACE "/csc.exe" "" csharp_dotnet_version_temp ${csharp_dotnet_version_temp})

            set (DOTNET_EXECUTABLE_VERSION "${csharp_dotnet_version_temp}" CACHE STRING "C# .NET compiler version" FORCE)
            set (DOTNET_FOUND ${csharp_dotnet_executable})
        endif()
    endforeach(csharp_dotnet_executable)
else()
    FIND_PROGRAM(DOTNET_FOUND dotnet)
endif()

if (DOTNET_FOUND)
    message (STATUS "Found dotnet.")
    message (STATUS "DOTNET_EXECUTABLE: " ${DOTNET_FOUND})

    if (WIN32)
        set (CSHARP_SUFFIX .dll)
    else()
        set (CSHARP_SUFFIX .so)
    endif()

    execute_process(COMMAND swig -csharp -c++ -I${PROJECT_SOURCE_DIR}/Wrappers/inc -o ${PROJECT_SOURCE_DIR}/Wrappers/inc/CoreInterface_cwrap.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/CsharpCore.i)
    execute_process(COMMAND swig -csharp -c++ -I${PROJECT_SOURCE_DIR}/Wrappers/inc -o ${PROJECT_SOURCE_DIR}/Wrappers/inc/ClientInterface_cwrap.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/CsharpClient.i)

    include_directories(${PROJECT_SOURCE_DIR}/AnnService ${PROJECT_SOURCE_DIR}/Wrappers)

    file(GLOB CORE_HDR_FILES ${PROJECT_SOURCE_DIR}/Wrappers/inc/CoreInterface.h)
    file(GLOB CORE_SRC_FILES ${PROJECT_SOURCE_DIR}/Wrappers/src/CoreInterface.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/CoreInterface_cwrap.cpp)
    add_library (CSHARPSPTAG SHARED ${CORE_SRC_FILES} ${CORE_HDR_FILES})
    set_target_properties(CSHARPSPTAG PROPERTIES SUFFIX ${CSHARP_SUFFIX})
    target_link_libraries(CSHARPSPTAG SPTAGLibStatic)

    file(GLOB CLIENT_HDR_FILES ${PROJECT_SOURCE_DIR}/Wrappers/inc/ClientInterface.h ${PROJECT_SOURCE_DIR}/AnnService/inc/Socket/*.h ${PROJECT_SOURCE_DIR}/AnnService/inc/Client/*.h)
    file(GLOB CLIENT_SRC_FILES ${PROJECT_SOURCE_DIR}/Wrappers/src/ClientInterface.cpp ${PROJECT_SOURCE_DIR}/AnnService/src/Socket/*.cpp ${PROJECT_SOURCE_DIR}/AnnService/src/Client/*.cpp ${PROJECT_SOURCE_DIR}/Wrappers/inc/ClientInterface_cwrap.cpp)
    add_library (CSHARPSPTAGClient SHARED ${CLIENT_SRC_FILES} ${CLIENT_HDR_FILES})
    set_target_properties(CSHARPSPTAGClient PROPERTIES SUFFIX ${CSHARP_SUFFIX})
    target_link_libraries(CSHARPSPTAGClient SPTAGLibStatic ${Boost_LIBRARIES})

    file(GLOB CSHARP_FILES ${PROJECT_SOURCE_DIR}/Wrappers/inc/*.cs)
    foreach(CSHARP_FILE ${CSHARP_FILES})
        message (STATUS "Add copy post-command for file " ${CSHARP_FILE})
        add_custom_command(TARGET CSHARPSPTAGClient POST_BUILD COMMAND ${CMAKE_COMMAND} -E copy ${CSHARP_FILE} ${EXECUTABLE_OUTPUT_PATH})
    endforeach(CSHARP_FILE)

    install(TARGETS CSHARPSPTAG CSHARPSPTAGClient
    RUNTIME DESTINATION bin
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib)
    install(FILES ${CSHARP_FILES} DESTINATION bin)
else()
    message (STATUS "Could not find C#.")
endif()

=== docs/examples/requirements.txt ===
numpy==1.15.0
matplotlib==2.2.2
Keras==2.2.4
Pillow==8.3.2
scikit_learn==0.21.3

=== AnnService/inc/Core/Common/cuda/Makefile ===
ARCH=sm_70

CUDA_HOME=/usr/local/cuda
FLAGS=-std=c++14 -Xptxas -O3

all: cuda_unit_tests

cuda_unit_tests: cuda_unit_tests.cu Refine.hxx
	nvcc ${FLAGS} -lineinfo --use_fast_math --gpu-architecture=${ARCH} -I../../../../ -I../../../../../../cub-1.8.0 -I${CUDA_HOME}/include -o cuda_unit_tests cuda_unit_tests.cu

## sptag 0.0~git20210816.e724b01+ds

=== debian/changelog ===
sptag (0.0~git20210816.e724b01+ds-3) unstable; urgency=medium

  * Override ctest timeout from default 25m to 12h

 -- Paul Wise <pabs@debian.org>  Sat, 21 Aug 2021 18:35:13 +0800

sptag (0.0~git20210816.e724b01+ds-2) unstable; urgency=medium

  * Switch to running tests from cmake/ctest
  * Make the test output verbose since they are long tests

 -- Paul Wise <pabs@debian.org>  Sat, 21 Aug 2021 15:04:45 +0800

sptag (0.0~git20210816.e724b01+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Add missing build dependencies
  * Add patches to fix adding compiler flags
  * Enable running the build tests
  * Declare compliance with Debian Policy version 4.6.0

 -- Paul Wise <pabs@debian.org>  Sat, 21 Aug 2021 13:53:04 +0800

sptag (0.0~git20210514.20d55e1+ds-1) unstable; urgency=medium

  * Initial release (Closes: #987809)

 -- Paul Wise <pabs@debian.org>  Fri, 30 Apr 2021 11:09:09 +0800

=== debian/control ===
Source: sptag
Section: math
Priority: optional
Maintainer: Paul Wise <pabs@debian.org>
Build-Depends:
 cmake (>= 3.12.0~),
 debhelper-compat (= 13),
 dh-sequence-python3,
 libboost-dev (>= 1.67~),
# remove system after 1.74, see 0001-Remove-unused-Boost-component-dependencies.patch
 libboost-system-dev (>= 1.67~),
 libboost-test-dev (>= 1.67~) <!nocheck>,
 python3-dev,
 swig (>= 3.0~),
Standards-Version: 4.6.0
Homepage: https://github.com/microsoft/SPTAG
Rules-Requires-Root: no

Package: python3-sptag
Section: python
# https://github.com/microsoft/SPTAG/issues/134
# https://github.com/microsoft/SPTAG/pull/136
Architecture: amd64 i386
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
XB-Python-Version:
 ${python3:Versions}
Description: Python distributed approximate nearest neighborhood search (ANN)
 A distributed approximate nearest neighborhood search (ANN) library
 which provides a high quality vector index build, search and
 distributed online serving toolkits for large scale vector search
 scenario.
 .
 This package contains the Python bindings.

Package: sptag
# https://github.com/microsoft/SPTAG/issues/134
# https://github.com/microsoft/SPTAG/pull/136
Architecture: amd64 i386
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: distributed approximate nearest neighborhood search (ANN)
 A distributed approximate nearest neighborhood search (ANN) library
 which provides a high quality vector index build, search and
 distributed online serving toolkits for large scale vector search
 scenario.
 .
 This package contains the client, server, aggregator and index
 builder and searcher.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

# ctest normally suppresses test output
# https://cmake.org/cmake/help/latest/manual/ctest.1.html#options
# but that could result in buildd timeout
# the tests take a long time, try 12h
override_dh_auto_test:
	dh_auto_test -- ARGS+="--verbose --timeout 43200"

## sptag 0.0~git20211105.0bf0ef5+ds

=== debian/changelog ===
sptag (0.0~git20211105.0bf0ef5+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
    - Add patch to fix FTBFS due to missing #include <mutex>
    - Add new Boost filesystem test dependency
  * Delegate test verbosity to debhelper when it is new enough
  * Reduce ctest timeout to 2h, current test runs are under 1h
  * Drop XB-Python-Version as it is not used by dh-python
  * Inform autodep8-python3 that the import name is SPTAG

 -- Paul Wise <pabs@debian.org>  Sat, 06 Nov 2021 10:16:23 +0800

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  debhelper-compat (= 13),
  dh-sequence-python3,
  libboost-dev (>= 1.67~),
+ libboost-filesystem-dev (>= 1.67~) <!nocheck>,
 # remove system after 1.74, see 0001-Remove-unused-Boost-component-dependencies.patch
  libboost-system-dev (>= 1.67~),
  libboost-test-dev (>= 1.67~) <!nocheck>,
@@ -27,8 +28,6 @@
  ${shlibs:Depends},
 Provides:
  ${python3:Provides},
-XB-Python-Version:
- ${python3:Versions}
 Description: Python distributed approximate nearest neighborhood search (ANN)
  A distributed approximate nearest neighborhood search (ANN) library
  which provides a high quality vector index build, search and

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# tests usually take just under an hour
# use 2h instead of the default 25m
TEST_ARGS = --timeout 7200

# ctest normally suppresses test output
# https://cmake.org/cmake/help/latest/manual/ctest.1.html#options
# debhelper 13.5 enables ctest output when build is not terse
# reimplement this when debhelper is too old to support this
ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
DEBHELPER_VERSION = $(strip $(shell dpkg-query -f '$${Version}' -W debhelper))
DEBHELPER_OK = $(strip $(shell dpkg --compare-versions $(DEBHELPER_VERSION) ge 13.5~; echo $$?))
ifneq ($(DEBHELPER_OK),0)
	TEST_ARGS += --verbose
endif
endif

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

%:
	dh $@

override_dh_auto_test:
	dh_auto_test -- ARGS+="$(TEST_ARGS)"

## sptag 0.0~git20211209.a84a9e4%2Bds

=== debian/changelog ===
sptag (0.0~git20211209.a84a9e4+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Paul Wise <pabs@debian.org>  Mon, 20 Dec 2021 12:24:06 +0800

sptag (0.0~git20211209.a84a9e4+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  - Drop support for i386 as upstream doesn't support it 
  * Increase ctest timeout to 3h due to timeout on repro builds server

 -- Paul Wise <pabs@debian.org>  Fri, 10 Dec 2021 14:46:49 +0800

## sptag 0.0~git20211209.a84a9e4+ds

=== debian/changelog ===
sptag (0.0~git20211209.a84a9e4+ds-1~bpo10+1) buster-backports-sloppy; urgency=medium

  * Rebuild for buster-backports-sloppy.

 -- Paul Wise <pabs@debian.org>  Mon, 20 Dec 2021 13:07:42 +0800

=== debian/control ===
--- 
+++ 
@@ -21,7 +21,8 @@
 Section: python
 # https://github.com/microsoft/SPTAG/issues/134
 # https://github.com/microsoft/SPTAG/pull/136
-Architecture: amd64 i386
+# https://github.com/microsoft/SPTAG/issues/246
+Architecture: amd64
 Depends:
  ${misc:Depends},
  ${python3:Depends},
@@ -39,7 +40,8 @@
 Package: sptag
 # https://github.com/microsoft/SPTAG/issues/134
 # https://github.com/microsoft/SPTAG/pull/136
-Architecture: amd64 i386
+# https://github.com/microsoft/SPTAG/issues/246
+Architecture: amd64
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},

=== debian/rules ===
--- 
+++ 
@@ -2,8 +2,9 @@
 #export DH_VERBOSE = 1
 
 # tests usually take just under an hour
-# use 2h instead of the default 25m
-TEST_ARGS = --timeout 7200
+# repro build servers can take longer
+# use 3h instead of the default 25m
+TEST_ARGS = --timeout 10800
 
 # ctest normally suppresses test output
 # https://cmake.org/cmake/help/latest/manual/ctest.1.html#options
@@ -18,10 +19,10 @@
 endif
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+#export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
 
 %:
 	dh $@
 
 override_dh_auto_test:
-	dh_auto_test -- ARGS+="$(TEST_ARGS)"
+	dh_auto_test -- ARGS+="$(TEST_ARGS)"

## sptag 0.0~git20220113.216a17a+ds

=== debian/changelog ===
sptag (0.0~git20220113.216a17a+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Reduce Boost version requirement in line with upstream

 -- Paul Wise <pabs@debian.org>  Tue, 25 Jan 2022 14:39:38 +0800

=== debian/control ===
--- 
+++ 
@@ -6,11 +6,11 @@
  cmake (>= 3.12.0~),
  debhelper-compat (= 13),
  dh-sequence-python3,
- libboost-dev (>= 1.67~),
- libboost-filesystem-dev (>= 1.67~) <!nocheck>,
+ libboost-dev (>= 1.66~),
+ libboost-filesystem-dev (>= 1.66~) <!nocheck>,
 # remove system after 1.74, see 0001-Remove-unused-Boost-component-dependencies.patch
- libboost-system-dev (>= 1.67~),
- libboost-test-dev (>= 1.67~) <!nocheck>,
+ libboost-system-dev (>= 1.66~),
+ libboost-test-dev (>= 1.66~) <!nocheck>,
  python3-dev,
  swig (>= 3.0~),
 Standards-Version: 4.6.0

## sptag 0.0~git20220211.c640c3c+ds

=== debian/changelog ===
sptag (0.0~git20220211.c640c3c+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Bump copyright year for a new file
  * Enable autodep8 tests

 -- Paul Wise <pabs@debian.org>  Wed, 16 Feb 2022 16:22:56 +0800

=== debian/control ===
--- 
+++ 
@@ -16,6 +16,7 @@
 Standards-Version: 4.6.0
 Homepage: https://github.com/microsoft/SPTAG
 Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-python
 
 Package: python3-sptag
 Section: python

=== debian/rules ===
--- 
+++ 
@@ -25,4 +25,4 @@
 	dh $@
 
 override_dh_auto_test:
-	dh_auto_test -- ARGS+="$(TEST_ARGS)" 
+	dh_auto_test -- ARGS+="$(TEST_ARGS)"

## sptag 0.0~git20220617.6f44a02+ds

=== debian/changelog ===
sptag (0.0~git20220617.6f44a02+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
    - Delete ThirdParty directory that includes zstd
    - Add patch to use system zstd
  * Add new build-dep on zstd
  * Declare compliance with Debian Policy version 4.6.1

 -- Paul Wise <pabs@debian.org>  Tue, 21 Jun 2022 15:13:57 +0800

sptag (0.0~git20220411.2a81715+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Add patch updating CMake files from C++ 14 to 17,
    upstream updated MSVC but forgot the CMake files.
  * Use cmake build system, ignoring the setup.py file
  * Bump copyright year for debian/ directory

 -- Paul Wise <pabs@debian.org>  Sat, 23 Apr 2022 16:37:32 +0800

## sptag 0.0~git20220729.a192a17+ds

=== debian/changelog ===
sptag (0.0~git20220729.a192a17+ds-2) unstable; urgency=medium

  * Add patch to fix build failure on tmpfs due to O_DIRECT

 -- Paul Wise <pabs@debian.org>  Mon, 01 Aug 2022 10:38:33 +0800

sptag (0.0~git20220729.a192a17+ds-1) unstable; urgency=medium

  * New upstream snapshot.
  * Add patch to print file open error info, should help debug failure

 -- Paul Wise <pabs@debian.org>  Sun, 31 Jul 2022 15:24:38 +0800

sptag (0.0~git20220718.5ab4ced+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Add unmerged upstream patch fixing reconstruct tests (Closes: #1013563)
  * Add patch to switch from AVX512 by default to GCC FMV, fixes test failure

 -- Paul Wise <pabs@debian.org>  Mon, 18 Jul 2022 14:02:12 +0800

=== debian/control ===
--- 
+++ 
@@ -11,9 +11,10 @@
 # remove system after 1.74, see 0001-Remove-unused-Boost-component-dependencies.patch
  libboost-system-dev (>= 1.66~),
  libboost-test-dev (>= 1.66~) <!nocheck>,
+ libzstd-dev,
  python3-dev,
  swig (>= 3.0~),
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Homepage: https://github.com/microsoft/SPTAG
 Rules-Requires-Root: no
 Testsuite: autopkgtest-pkg-python

=== debian/rules ===
--- 
+++ 
@@ -22,7 +22,7 @@
 #export DEB_CFLAGS_MAINT_APPEND = -Wall -pedantic
 
 %:
-	dh $@
+	dh $@ --buildsystem=cmake
 
 override_dh_auto_test:
 	dh_auto_test -- ARGS+="$(TEST_ARGS)"

## sptag 0.0~git20221103.3d76e5e+ds

=== debian/changelog ===
sptag (0.0~git20221103.3d76e5e+ds-1build1) lunar; urgency=medium

  * No-change rebuild with Python 3.11 as default

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 25 Dec 2022 20:43:07 +0000

sptag (0.0~git20221103.3d76e5e+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches

 -- Paul Wise <pabs@debian.org>  Sun, 13 Nov 2022 13:53:58 +0800

## sptag 0.0~git20230106.de5b7f8+ds

=== debian/changelog ===
sptag (0.0~git20230106.de5b7f8+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Add patch fixing various spelling and grammar errors
  * Declare compliance with Debian Policy version 4.6.1, no changes needed

 -- Paul Wise <pabs@debian.org>  Sun, 05 Feb 2023 12:04:44 +0800

## sptag 0.0~git20230301.0207479+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -78,7 +78,7 @@
     message (FATAL_ERROR "Could no find openmp!")
 endif()
 
-find_package(Boost 1.67 COMPONENTS system thread serialization wserialization regex filesystem)
+find_package(Boost 1.66 COMPONENTS system thread serialization wserialization regex filesystem)
 if (Boost_FOUND)
     include_directories (${Boost_INCLUDE_DIR})
     link_directories (${Boost_LIBRARY_DIR})
@@ -92,6 +92,9 @@
 
 option(GPU "GPU" ON)
 option(LIBRARYONLY "LIBRARYONLY" OFF)
+
+add_subdirectory (ThirdParty/zstd/build/cmake)
+
 add_subdirectory (AnnService)
 add_subdirectory (Test)
 add_subdirectory (GPUSupport)

=== AnnService/CMakeLists.txt ===
--- 
+++ 
@@ -2,40 +2,45 @@
 # Licensed under the MIT License.
 
 set(AnnService ${PROJECT_SOURCE_DIR}/AnnService)
+set(Zstd ${PROJECT_SOURCE_DIR}/ThirdParty/zstd)
 
 include_directories(${AnnService})
+include_directories(${Zstd}/lib)
 
 file(GLOB_RECURSE HDR_FILES ${AnnService}/inc/Core/*.h  ${AnnService}/inc/Helper/*.h)
 file(GLOB_RECURSE SRC_FILES ${AnnService}/src/Core/*.cpp ${AnnService}/src/Helper/*.cpp)
 
 list(REMOVE_ITEM HDR_FILES
-    ${AnnService}/inc/Core/Common/DistanceUtils.h 
+    ${AnnService}/inc/Core/Common/DistanceUtils.h
+    ${AnnService}/inc/Core/Common/SIMDUtils.h 
     ${AnnService}/inc/Core/Common/InstructionUtils.h
     ${AnnService}/inc/Core/Common/CommonUtils.h
     )
 
 list(REMOVE_ITEM SRC_FILES
     ${AnnService}/src/Core/Common/DistanceUtils.cpp
+    ${AnnService}/src/Core/Common/SIMDUtils.cpp
     ${AnnService}/src/Core/Common/InstructionUtils.cpp
     )
 
 add_library (DistanceUtils STATIC 
-    inc/Core/Common/DistanceUtils.h 
+    inc/Core/Common/DistanceUtils.h
+    inc/Core/Common/SIMDUtils.h
     inc/Core/Common/InstructionUtils.h
     inc/Core/Common/CommonUtils.h
-    inc/Core/Common/IQuantizer.h
     src/Core/Common/DistanceUtils.cpp
+    src/Core/Common/SIMDUtils.cpp
     src/Core/Common/InstructionUtils.cpp
     )
 
 if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
-    target_compile_options(DistanceUtils PRIVATE -mavx2 -mavx -msse -msse2 -fPIC)
+    target_compile_options(DistanceUtils PRIVATE -mavx2 -mavx -msse -msse2 -mavx512f -mavx512bw -mavx512dq -fPIC)
 endif()
 
 add_library (SPTAGLib SHARED ${SRC_FILES} ${HDR_FILES})
-target_link_libraries (SPTAGLib DistanceUtils)
+target_link_libraries (SPTAGLib DistanceUtils libzstd_shared)
 add_library (SPTAGLibStatic STATIC ${SRC_FILES} ${HDR_FILES})
-target_link_libraries (SPTAGLibStatic DistanceUtils)
+target_link_libraries (SPTAGLibStatic DistanceUtils libzstd_static)
 if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
     target_compile_options(SPTAGLibStatic PRIVATE -fPIC)
 endif()
@@ -69,25 +74,19 @@
     add_executable (indexsearcher ${SEARCHER_FILES})
     target_link_libraries(indexsearcher ${Boost_LIBRARIES} SPTAGLibStatic)
     
-    install(TARGETS server client aggregator indexbuilder indexsearcher
+    file(GLOB QUANTIZER_HDR_FILES ${AnnService}/inc/Quantizer/*.h)
+    file(GLOB QUANTIZER_FILES ${AnnService}/src/Quantizer/*.cpp)
+    add_executable (quantizer ${QUANTIZER_FILES} ${QUANTIZER_HDR_FILES})
+    target_link_libraries(quantizer ${Boost_LIBRARIES} SPTAGLibStatic)
+
+    install(TARGETS server client aggregator indexbuilder indexsearcher quantizer
       RUNTIME DESTINATION bin
       ARCHIVE DESTINATION lib
       LIBRARY DESTINATION lib)
 endif()
 
-set(VECTORSEARCH_INC_DIR ${AnnService}/inc/SSDServing/VectorSearch)
-set(VECTORSEARCH_IMP_DIR ${AnnService}/src/SSDServing/VectorSearch)
 file(GLOB_RECURSE SSD_SERVING_HDR_FILES ${AnnService}/inc/SSDServing/*.h)
 file(GLOB_RECURSE SSD_SERVING_FILES ${AnnService}/src/SSDServing/*.cpp)
-if(NOT WIN32)
-    list(REMOVE_ITEM SSD_SERVING_HDR_FILES 
-            ${VECTORSEARCH_INC_DIR}/AsyncFileReader.h
-            )
-elseif(WIN32)
-    list(REMOVE_ITEM SSD_SERVING_HDR_FILES 
-            ${VECTORSEARCH_INC_DIR}/AsyncFileReaderLinux.h
-            )
-endif()
 
 add_executable(ssdserving ${SSD_SERVING_HDR_FILES} ${SSD_SERVING_FILES})
 target_link_libraries(ssdserving SPTAGLibStatic ${Boost_LIBRARIES})

=== GPUSupport/CMakeLists.txt ===
--- 
+++ 
@@ -12,15 +12,15 @@
     message (STATUS "Include Path:" ${CUDA_INCLUDE_DIRS})
     message (STATUS "Library Path:" ${CUDA_LIBRARIES})
     if(${CMAKE_CXX_COMPILER_ID} STREQUAL "GNU")
-        set (CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -Xcompiler -fPIC -Xcompiler -fopenmp -std=c++14 -Xptxas -O3 --use_fast_math --disable-warnings
+        set (CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -Xcompiler -fPIC -Xcompiler -fopenmp -std=c++14 -Xptxas -O3 --use_fast_math --disable-warnings -lineinfo
         -gencode arch=compute_70,code=sm_70
-        -gencode arch=compute_61,code=sm_61
-        -gencode arch=compute_60,code=sm_60" )
+        -gencode arch=compute_75,code=sm_75
+        -gencode arch=compute_80,code=sm_80" )
     elseif(WIN32)
         set (CUDA_NVCC_FLAGS "${CUDA_NVCC_FLAGS} -Xcompiler /openmp -Xcompiler /std:c++14 -Xcompiler /Zc:__cplusplus -Xcompiler /FS --use_fast_math
         -gencode arch=compute_70,code=sm_70
-        -gencode arch=compute_61,code=sm_61
-        -gencode arch=compute_60,code=sm_60" )
+        -gencode arch=compute_75,code=sm_75
+        -gencode arch=compute_80,code=sm_80" )
     endif()
 
     message (STATUS "CUDA_NVCC_FLAGS:" ${CUDA_NVCC_FLAGS})
@@ -29,6 +29,8 @@
 
     include_directories(${AnnService})
 
+    include_directories(${PROJECT_SOURCE_DIR}/ThirdParty/zstd/lib)   
+
     file(GLOB_RECURSE GPU_HDR_FILES ${AnnService}/inc/Core/*.h  ${AnnService}/inc/Helper/*.h ${AnnService}/inc/Core/Common/cuda/*)
     file(GLOB_RECURSE GPU_SRC_FILES ${AnnService}/src/Core/*.cpp ${AnnService}/src/Helper/*.cpp ${AnnService}/src/Core/Common/Kernel.cu)
 
@@ -36,10 +38,12 @@
         ${AnnService}/inc/Core/Common/DistanceUtils.h
         ${AnnService}/inc/Core/Common/InstructionUtils.h
         ${AnnService}/inc/Core/Common/CommonUtils.h
+        ${AnnService}/inc/Core/Common/cuda/tests/
     )
     list(REMOVE_ITEM GPU_SRC_FILES
         ${AnnService}/src/Core/Common/DistanceUtils.cpp
         ${AnnService}/src/Core/Common/InstructionUtils.cpp
+        ${AnnService}/src/Core/Common/cuda/tests/
     )
 
     set_source_files_properties(${GPU_SRC_FILES} PROPERTIES CUDA_SOURCE_PROPERTY_FORMAT OBJ)
@@ -50,11 +54,11 @@
     endif()
 
     CUDA_ADD_LIBRARY(GPUSPTAGLib SHARED ${GPU_SRC_FILES} ${GPU_HDR_FILES})
-    target_link_libraries(GPUSPTAGLib DistanceUtils ${Boost_LIBRARIES} ${CUDA_LIBRARIES})
+    target_link_libraries(GPUSPTAGLib DistanceUtils ${Boost_LIBRARIES} ${CUDA_LIBRARIES} libzstd_shared)
     target_compile_definitions(GPUSPTAGLib PRIVATE ${Definition})
 
     CUDA_ADD_LIBRARY(GPUSPTAGLibStatic STATIC ${GPU_SRC_FILES} ${GPU_HDR_FILES})
-    target_link_libraries(GPUSPTAGLibStatic DistanceUtils ${Boost_LIBRARIES} ${CUDA_LIBRARIES})
+    target_link_libraries(GPUSPTAGLibStatic DistanceUtils ${Boost_LIBRARIES} ${CUDA_LIBRARIES} libzstd_static)
     target_compile_definitions(GPUSPTAGLibStatic PRIVATE ${Definition})
     add_dependencies(GPUSPTAGLibStatic GPUSPTAGLib)

=== Test/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
       message (STATUS "BOOST_TEST_DYN_LINK")
     endif()
 
-    find_package(Boost 1.67 COMPONENTS system thread serialization wserialization regex filesystem unit_test_framework)
+    find_package(Boost 1.66 COMPONENTS system thread serialization wserialization regex filesystem unit_test_framework)
     if (Boost_FOUND)
         include_directories (${Boost_INCLUDE_DIR})
         link_directories (${Boost_LIBRARY_DIR})

=== Wrappers/CMakeLists.txt ===
--- 
+++ 
@@ -1,34 +1,34 @@
 # Copyright (c) Microsoft Corporation. All rights reserved.
 # Licensed under the MIT License.
 
-find_package(Python2 COMPONENTS Development)
+
+find_package(Python3 COMPONENTS Development)
 
 find_package(CUDA)
 
-if (NOT GPU)
+if ((NOT GPU) OR (NOT Python3_FOUND))
     set (CUDA_FOUND false)
 endif()
 
 if (CUDA_FOUND)
     message (STATUS "Found cuda.")
-    set (Python2_FOUND false)
 else()
     message (STATUS "Could not find cuda.")
 endif()
 
-if (Python2_FOUND)
-    include_directories (${Python2_INCLUDE_DIRS})
-    link_directories (${Python2_LIBRARY_DIRS})
-    set (Python_INCLUDE_DIRS ${Python2_INCLUDE_DIRS})
-    set (Python_LIBRARIES ${Python2_LIBRARIES})
+if (Python3_FOUND)
+    include_directories (${Python3_INCLUDE_DIRS})
+    link_directories (${Python3_LIBRARY_DIRS})
+    set (Python_INCLUDE_DIRS ${Python3_INCLUDE_DIRS})
+    set (Python_LIBRARIES ${Python3_LIBRARIES})
     set (Python_FOUND true)
 else()
-    find_package(Python3 COMPONENTS Development)
-    if (Python3_FOUND)
-        include_directories (${Python3_INCLUDE_DIRS})
-        link_directories (${Python3_LIBRARY_DIRS})
-        set (Python_INCLUDE_DIRS ${Python3_INCLUDE_DIRS})
-        set (Python_LIBRARIES ${Python3_LIBRARIES})
+    find_package(Python2 COMPONENTS Development)
+    if (Python2_FOUND)
+        include_directories (${Python2_INCLUDE_DIRS})
+        link_directories (${Python2_LIBRARY_DIRS})
+        set (Python_INCLUDE_DIRS ${Python2_INCLUDE_DIRS})
+        set (Python_LIBRARIES ${Python2_LIBRARIES})
         set (Python_FOUND true)
     endif()
 endif()

=== docs/examples/requirements.txt ===
numpy==1.21.0
matplotlib==2.2.2
Keras==2.2.4
Pillow==9.0.1
scikit_learn==0.21.3

=== AnnService/inc/Core/Common/cuda/tests/Makefile ===
ARCH=sm_70

CUDA_HOME=/usr/local/cuda
FLAGS=-std=c++14 -Xptxas -O3

all: test_dists

test_dists: cuda_unit_tests.cu ../KNN.hxx ../Distance.hxx
	nvcc ${FLAGS} -lineinfo --use_fast_math --gpu-architecture=${ARCH} -I${CUDA_HOME}/include -I ../../../../../  -o test_dists cuda_unit_tests.cu

=== debian/changelog ===
sptag (0.0~git20230301.0207479+ds-1) unstable; urgency=medium

  * New upstream snapshot.
    - Refresh patches
  * Declare compliance with Debian Policy version 4.6.2, no changes needed

 -- Paul Wise <pabs@debian.org>  Wed, 01 Mar 2023 16:36:13 +0800

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
  libzstd-dev,
  python3-dev,
  swig (>= 3.0~),
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/microsoft/SPTAG
 Rules-Requires-Root: no
 Testsuite: autopkgtest-pkg-python
